// Code generated by astool. DO NOT EDIT.

package propertyinteractiontarget

import (
	anyuri "code.superseriousbusiness.org/activity/streams/values/anyURI"
	vocab "code.superseriousbusiness.org/activity/streams/vocab"
	"fmt"
	"net/url"
)

// GoToSocialInteractionTargetPropertyIterator is an iterator for a property. It
// is permitted to be a single nilable value type.
type GoToSocialInteractionTargetPropertyIterator struct {
	xmlschemaAnyURIMember *url.URL
	unknown               interface{}
	alias                 string
	myIdx                 int
	parent                vocab.GoToSocialInteractionTargetProperty
}

// NewGoToSocialInteractionTargetPropertyIterator creates a new
// GoToSocialInteractionTarget property.
func NewGoToSocialInteractionTargetPropertyIterator() *GoToSocialInteractionTargetPropertyIterator {
	return &GoToSocialInteractionTargetPropertyIterator{alias: ""}
}

// deserializeGoToSocialInteractionTargetPropertyIterator creates an iterator from
// an element that has been unmarshalled from a text or binary format.
func deserializeGoToSocialInteractionTargetPropertyIterator(i interface{}, aliasMap map[string]string) (*GoToSocialInteractionTargetPropertyIterator, error) {
	alias := ""
	if a, ok := aliasMap["https://gotosocial.org/ns"]; ok {
		alias = a
	}
	if v, err := anyuri.DeserializeAnyURI(i); err == nil {
		this := &GoToSocialInteractionTargetPropertyIterator{
			alias:                 alias,
			xmlschemaAnyURIMember: v,
		}
		return this, nil
	}
	this := &GoToSocialInteractionTargetPropertyIterator{
		alias:   alias,
		unknown: i,
	}
	return this, nil
}

// Get returns the value of this property. When IsXMLSchemaAnyURI returns false,
// Get will return any arbitrary value.
func (this GoToSocialInteractionTargetPropertyIterator) Get() *url.URL {
	return this.xmlschemaAnyURIMember
}

// GetIRI returns the IRI of this property. When IsIRI returns false, GetIRI will
// return any arbitrary value.
func (this GoToSocialInteractionTargetPropertyIterator) GetIRI() *url.URL {
	return this.xmlschemaAnyURIMember
}

// HasAny returns true if the value or IRI is set.
func (this GoToSocialInteractionTargetPropertyIterator) HasAny() bool {
	return this.IsXMLSchemaAnyURI()
}

// IsIRI returns true if this property is an IRI.
func (this GoToSocialInteractionTargetPropertyIterator) IsIRI() bool {
	return this.xmlschemaAnyURIMember != nil
}

// IsXMLSchemaAnyURI returns true if this property is set and not an IRI.
func (this GoToSocialInteractionTargetPropertyIterator) IsXMLSchemaAnyURI() bool {
	return this.xmlschemaAnyURIMember != nil
}

// JSONLDContext returns the JSONLD URIs required in the context string for this
// property and the specific values that are set. The value in the map is the
// alias used to import the property's value or values.
func (this GoToSocialInteractionTargetPropertyIterator) JSONLDContext() map[string]string {
	m := map[string]string{"https://gotosocial.org/ns": this.alias}
	var child map[string]string

	/*
	   Since the literal maps in this function are determined at
	   code-generation time, this loop should not overwrite an existing key with a
	   new value.
	*/
	for k, v := range child {
		m[k] = v
	}
	return m
}

// KindIndex computes an arbitrary value for indexing this kind of value. This is
// a leaky API detail only for folks looking to replace the go-fed
// implementation. Applications should not use this method.
func (this GoToSocialInteractionTargetPropertyIterator) KindIndex() int {
	if this.IsXMLSchemaAnyURI() {
		return 0
	}
	if this.IsIRI() {
		return -2
	}
	return -1
}

// LessThan compares two instances of this property with an arbitrary but stable
// comparison. Applications should not use this because it is only meant to
// help alternative implementations to go-fed to be able to normalize
// nonfunctional properties.
func (this GoToSocialInteractionTargetPropertyIterator) LessThan(o vocab.GoToSocialInteractionTargetPropertyIterator) bool {
	if this.IsIRI() {
		// IRIs are always less than other values, none, or unknowns
		return true
	} else if o.IsIRI() {
		// This other, none, or unknown value is always greater than IRIs
		return false
	}
	// LessThan comparison for the single value or unknown value.
	if !this.IsXMLSchemaAnyURI() && !o.IsXMLSchemaAnyURI() {
		// Both are unknowns.
		return false
	} else if this.IsXMLSchemaAnyURI() && !o.IsXMLSchemaAnyURI() {
		// Values are always greater than unknown values.
		return false
	} else if !this.IsXMLSchemaAnyURI() && o.IsXMLSchemaAnyURI() {
		// Unknowns are always less than known values.
		return true
	} else {
		// Actual comparison.
		return anyuri.LessAnyURI(this.Get(), o.Get())
	}
}

// Name returns the name of this property: "GoToSocialInteractionTarget".
func (this GoToSocialInteractionTargetPropertyIterator) Name() string {
	if len(this.alias) > 0 {
		return this.alias + ":" + "GoToSocialInteractionTarget"
	} else {
		return "GoToSocialInteractionTarget"
	}
}

// Next returns the next iterator, or nil if there is no next iterator.
func (this GoToSocialInteractionTargetPropertyIterator) Next() vocab.GoToSocialInteractionTargetPropertyIterator {
	if this.myIdx+1 >= this.parent.Len() {
		return nil
	} else {
		return this.parent.At(this.myIdx + 1)
	}
}

// Prev returns the previous iterator, or nil if there is no previous iterator.
func (this GoToSocialInteractionTargetPropertyIterator) Prev() vocab.GoToSocialInteractionTargetPropertyIterator {
	if this.myIdx-1 < 0 {
		return nil
	} else {
		return this.parent.At(this.myIdx - 1)
	}
}

// Set sets the value of this property. Calling IsXMLSchemaAnyURI afterwards will
// return true.
func (this *GoToSocialInteractionTargetPropertyIterator) Set(v *url.URL) {
	this.clear()
	this.xmlschemaAnyURIMember = v
}

// SetIRI sets the value of this property. Calling IsIRI afterwards will return
// true.
func (this *GoToSocialInteractionTargetPropertyIterator) SetIRI(v *url.URL) {
	this.clear()
	this.Set(v)
}

// clear ensures no value of this property is set. Calling IsXMLSchemaAnyURI
// afterwards will return false.
func (this *GoToSocialInteractionTargetPropertyIterator) clear() {
	this.unknown = nil
	this.xmlschemaAnyURIMember = nil
}

// serialize converts this into an interface representation suitable for
// marshalling into a text or binary format. Applications should not need this
// function as most typical use cases serialize types instead of individual
// properties. It is exposed for alternatives to go-fed implementations to use.
func (this GoToSocialInteractionTargetPropertyIterator) serialize() (interface{}, error) {
	if this.IsXMLSchemaAnyURI() {
		return anyuri.SerializeAnyURI(this.Get())
	}
	return this.unknown, nil
}

// GoToSocialInteractionTargetProperty is the non-functional property
// "interactionTarget". It is permitted to have one or more values, and of
// different value types.
type GoToSocialInteractionTargetProperty struct {
	properties []*GoToSocialInteractionTargetPropertyIterator
	alias      string
}

// DeserializeInteractionTargetProperty creates a "interactionTarget" property
// from an interface representation that has been unmarshalled from a text or
// binary format.
func DeserializeInteractionTargetProperty(m map[string]interface{}, aliasMap map[string]string) (vocab.GoToSocialInteractionTargetProperty, error) {
	alias := ""
	if a, ok := aliasMap["https://gotosocial.org/ns"]; ok {
		alias = a
	}
	propName := "interactionTarget"
	if len(alias) > 0 {
		propName = fmt.Sprintf("%s:%s", alias, "interactionTarget")
	}
	i, ok := m[propName]

	if ok {
		this := &GoToSocialInteractionTargetProperty{
			alias:      alias,
			properties: []*GoToSocialInteractionTargetPropertyIterator{},
		}
		if list, ok := i.([]interface{}); ok {
			for _, iterator := range list {
				if p, err := deserializeGoToSocialInteractionTargetPropertyIterator(iterator, aliasMap); err != nil {
					return this, err
				} else if p != nil {
					this.properties = append(this.properties, p)
				}
			}
		} else {
			if p, err := deserializeGoToSocialInteractionTargetPropertyIterator(i, aliasMap); err != nil {
				return this, err
			} else if p != nil {
				this.properties = append(this.properties, p)
			}
		}
		// Set up the properties for iteration.
		for idx, ele := range this.properties {
			ele.parent = this
			ele.myIdx = idx
		}
		return this, nil
	}
	return nil, nil
}

// NewGoToSocialInteractionTargetProperty creates a new interactionTarget property.
func NewGoToSocialInteractionTargetProperty() *GoToSocialInteractionTargetProperty {
	return &GoToSocialInteractionTargetProperty{alias: ""}
}

// AppendIRI appends an IRI value to the back of a list of the property
// "interactionTarget"
func (this *GoToSocialInteractionTargetProperty) AppendIRI(v *url.URL) {
	this.properties = append(this.properties, &GoToSocialInteractionTargetPropertyIterator{
		alias:                 this.alias,
		myIdx:                 this.Len(),
		parent:                this,
		xmlschemaAnyURIMember: v,
	})
}

// AppendXMLSchemaAnyURI appends a anyURI value to the back of a list of the
// property "interactionTarget". Invalidates iterators that are traversing
// using Prev.
func (this *GoToSocialInteractionTargetProperty) AppendXMLSchemaAnyURI(v *url.URL) {
	this.properties = append(this.properties, &GoToSocialInteractionTargetPropertyIterator{
		alias:                 this.alias,
		myIdx:                 this.Len(),
		parent:                this,
		xmlschemaAnyURIMember: v,
	})
}

// At returns the property value for the specified index. Panics if the index is
// out of bounds.
func (this GoToSocialInteractionTargetProperty) At(index int) vocab.GoToSocialInteractionTargetPropertyIterator {
	return this.properties[index]
}

// Begin returns the first iterator, or nil if empty. Can be used with the
// iterator's Next method and this property's End method to iterate from front
// to back through all values.
func (this GoToSocialInteractionTargetProperty) Begin() vocab.GoToSocialInteractionTargetPropertyIterator {
	if this.Empty() {
		return nil
	} else {
		return this.properties[0]
	}
}

// Empty returns returns true if there are no elements.
func (this GoToSocialInteractionTargetProperty) Empty() bool {
	return this.Len() == 0
}

// End returns beyond-the-last iterator, which is nil. Can be used with the
// iterator's Next method and this property's Begin method to iterate from
// front to back through all values.
func (this GoToSocialInteractionTargetProperty) End() vocab.GoToSocialInteractionTargetPropertyIterator {
	return nil
}

// Insert inserts an IRI value at the specified index for a property
// "interactionTarget". Existing elements at that index and higher are shifted
// back once. Invalidates all iterators.
func (this *GoToSocialInteractionTargetProperty) InsertIRI(idx int, v *url.URL) {
	this.properties = append(this.properties, nil)
	copy(this.properties[idx+1:], this.properties[idx:])
	this.properties[idx] = &GoToSocialInteractionTargetPropertyIterator{
		alias:                 this.alias,
		myIdx:                 idx,
		parent:                this,
		xmlschemaAnyURIMember: v,
	}
	for i := idx; i < this.Len(); i++ {
		(this.properties)[i].myIdx = i
	}
}

// InsertXMLSchemaAnyURI inserts a anyURI value at the specified index for a
// property "interactionTarget". Existing elements at that index and higher
// are shifted back once. Invalidates all iterators.
func (this *GoToSocialInteractionTargetProperty) InsertXMLSchemaAnyURI(idx int, v *url.URL) {
	this.properties = append(this.properties, nil)
	copy(this.properties[idx+1:], this.properties[idx:])
	this.properties[idx] = &GoToSocialInteractionTargetPropertyIterator{
		alias:                 this.alias,
		myIdx:                 idx,
		parent:                this,
		xmlschemaAnyURIMember: v,
	}
	for i := idx; i < this.Len(); i++ {
		(this.properties)[i].myIdx = i
	}
}

// JSONLDContext returns the JSONLD URIs required in the context string for this
// property and the specific values that are set. The value in the map is the
// alias used to import the property's value or values.
func (this GoToSocialInteractionTargetProperty) JSONLDContext() map[string]string {
	m := map[string]string{"https://gotosocial.org/ns": this.alias}
	for _, elem := range this.properties {
		child := elem.JSONLDContext()
		/*
		   Since the literal maps in this function are determined at
		   code-generation time, this loop should not overwrite an existing key with a
		   new value.
		*/
		for k, v := range child {
			m[k] = v
		}
	}
	return m
}

// KindIndex computes an arbitrary value for indexing this kind of value. This is
// a leaky API method specifically needed only for alternate implementations
// for go-fed. Applications should not use this method. Panics if the index is
// out of bounds.
func (this GoToSocialInteractionTargetProperty) KindIndex(idx int) int {
	return this.properties[idx].KindIndex()
}

// Len returns the number of values that exist for the "interactionTarget"
// property.
func (this GoToSocialInteractionTargetProperty) Len() (length int) {
	return len(this.properties)
}

// Less computes whether another property is less than this one. Mixing types
// results in a consistent but arbitrary ordering
func (this GoToSocialInteractionTargetProperty) Less(i, j int) bool {
	idx1 := this.KindIndex(i)
	idx2 := this.KindIndex(j)
	if idx1 < idx2 {
		return true
	} else if idx1 == idx2 {
		if idx1 == 0 {
			lhs := this.properties[i].Get()
			rhs := this.properties[j].Get()
			return anyuri.LessAnyURI(lhs, rhs)
		} else if idx1 == -2 {
			lhs := this.properties[i].GetIRI()
			rhs := this.properties[j].GetIRI()
			return lhs.String() < rhs.String()
		}
	}
	return false
}

// LessThan compares two instances of this property with an arbitrary but stable
// comparison. Applications should not use this because it is only meant to
// help alternative implementations to go-fed to be able to normalize
// nonfunctional properties.
func (this GoToSocialInteractionTargetProperty) LessThan(o vocab.GoToSocialInteractionTargetProperty) bool {
	l1 := this.Len()
	l2 := o.Len()
	l := l1
	if l2 < l1 {
		l = l2
	}
	for i := 0; i < l; i++ {
		if this.properties[i].LessThan(o.At(i)) {
			return true
		} else if o.At(i).LessThan(this.properties[i]) {
			return false
		}
	}
	return l1 < l2
}

// Name returns the name of this property ("interactionTarget") with any alias.
func (this GoToSocialInteractionTargetProperty) Name() string {
	if len(this.alias) > 0 {
		return this.alias + ":" + "interactionTarget"
	} else {
		return "interactionTarget"
	}
}

// PrependIRI prepends an IRI value to the front of a list of the property
// "interactionTarget".
func (this *GoToSocialInteractionTargetProperty) PrependIRI(v *url.URL) {
	this.properties = append([]*GoToSocialInteractionTargetPropertyIterator{{
		alias:                 this.alias,
		myIdx:                 0,
		parent:                this,
		xmlschemaAnyURIMember: v,
	}}, this.properties...)
	for i := 1; i < this.Len(); i++ {
		(this.properties)[i].myIdx = i
	}
}

// PrependXMLSchemaAnyURI prepends a anyURI value to the front of a list of the
// property "interactionTarget". Invalidates all iterators.
func (this *GoToSocialInteractionTargetProperty) PrependXMLSchemaAnyURI(v *url.URL) {
	this.properties = append([]*GoToSocialInteractionTargetPropertyIterator{{
		alias:                 this.alias,
		myIdx:                 0,
		parent:                this,
		xmlschemaAnyURIMember: v,
	}}, this.properties...)
	for i := 1; i < this.Len(); i++ {
		(this.properties)[i].myIdx = i
	}
}

// Remove deletes an element at the specified index from a list of the property
// "interactionTarget", regardless of its type. Panics if the index is out of
// bounds. Invalidates all iterators.
func (this *GoToSocialInteractionTargetProperty) Remove(idx int) {
	(this.properties)[idx].parent = nil
	copy((this.properties)[idx:], (this.properties)[idx+1:])
	(this.properties)[len(this.properties)-1] = &GoToSocialInteractionTargetPropertyIterator{}
	this.properties = (this.properties)[:len(this.properties)-1]
	for i := idx; i < this.Len(); i++ {
		(this.properties)[i].myIdx = i
	}
}

// Serialize converts this into an interface representation suitable for
// marshalling into a text or binary format. Applications should not need this
// function as most typical use cases serialize types instead of individual
// properties. It is exposed for alternatives to go-fed implementations to use.
func (this GoToSocialInteractionTargetProperty) Serialize() (interface{}, error) {
	s := make([]interface{}, 0, len(this.properties))
	for _, iterator := range this.properties {
		if b, err := iterator.serialize(); err != nil {
			return s, err
		} else {
			s = append(s, b)
		}
	}
	// Shortcut: if serializing one value, don't return an array -- pretty sure other Fediverse software would choke on a "type" value with array, for example.
	if len(s) == 1 {
		return s[0], nil
	}
	return s, nil
}

// Set sets a anyURI value to be at the specified index for the property
// "interactionTarget". Panics if the index is out of bounds. Invalidates all
// iterators.
func (this *GoToSocialInteractionTargetProperty) Set(idx int, v *url.URL) {
	(this.properties)[idx].parent = nil
	(this.properties)[idx] = &GoToSocialInteractionTargetPropertyIterator{
		alias:                 this.alias,
		myIdx:                 idx,
		parent:                this,
		xmlschemaAnyURIMember: v,
	}
}

// SetIRI sets an IRI value to be at the specified index for the property
// "interactionTarget". Panics if the index is out of bounds.
func (this *GoToSocialInteractionTargetProperty) SetIRI(idx int, v *url.URL) {
	(this.properties)[idx].parent = nil
	(this.properties)[idx] = &GoToSocialInteractionTargetPropertyIterator{
		alias:                 this.alias,
		myIdx:                 idx,
		parent:                this,
		xmlschemaAnyURIMember: v,
	}
}

// Swap swaps the location of values at two indices for the "interactionTarget"
// property.
func (this GoToSocialInteractionTargetProperty) Swap(i, j int) {
	this.properties[i], this.properties[j] = this.properties[j], this.properties[i]
}
